"use strict";
// The require scope
var __webpack_require__ = {};
/************************************************************************/ // webpack/runtime/compat_get_default_export
(()=>{
    // getDefaultExport function for compatibility with non-ESM modules
    __webpack_require__.n = function(module) {
        var getter = module && module.__esModule ? function() {
            return module['default'];
        } : function() {
            return module;
        };
        __webpack_require__.d(getter, {
            a: getter
        });
        return getter;
    };
})();
// webpack/runtime/define_property_getters
(()=>{
    __webpack_require__.d = function(exports1, definition) {
        for(var key in definition)if (__webpack_require__.o(definition, key) && !__webpack_require__.o(exports1, key)) Object.defineProperty(exports1, key, {
            enumerable: true,
            get: definition[key]
        });
    };
})();
// webpack/runtime/has_own_property
(()=>{
    __webpack_require__.o = function(obj, prop) {
        return Object.prototype.hasOwnProperty.call(obj, prop);
    };
})();
// webpack/runtime/make_namespace_object
(()=>{
    // define __esModule on exports
    __webpack_require__.r = function(exports1) {
        if ('undefined' != typeof Symbol && Symbol.toStringTag) Object.defineProperty(exports1, Symbol.toStringTag, {
            value: 'Module'
        });
        Object.defineProperty(exports1, '__esModule', {
            value: true
        });
    };
})();
/************************************************************************/ var __webpack_exports__ = {};
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);
// EXPORTS
__webpack_require__.d(__webpack_exports__, {
    pluginCheckSyntax: ()=>/* binding */ pluginCheckSyntax,
    PLUGIN_CHECK_SYNTAX_NAME: ()=>/* binding */ PLUGIN_CHECK_SYNTAX_NAME,
    CheckSyntax: ()=>/* reexport */ CheckSyntax
});
const external_node_path_namespaceObject = require("node:path");
const external_node_fs_namespaceObject = require("node:fs");
var external_node_fs_default = /*#__PURE__*/ __webpack_require__.n(external_node_fs_namespaceObject);
const external_acorn_namespaceObject = require("acorn");
const external_browserslist_to_es_version_namespaceObject = require("browserslist-to-es-version");
const external_picocolors_namespaceObject = require("picocolors");
var external_picocolors_default = /*#__PURE__*/ __webpack_require__.n(external_picocolors_namespaceObject);
const external_source_map_namespaceObject = require("source-map");
function _define_property(obj, key, value) {
    if (key in obj) Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
    });
    else obj[key] = value;
    return obj;
}
class ECMASyntaxError extends Error {
    constructor(message, options){
        super(message), _define_property(this, "source", void 0), _define_property(this, "output", void 0);
        this.source = options.source;
        this.output = options.output;
    }
}
function checkIsExclude(path, exclude) {
    if (!exclude) return false;
    const excludes = Array.isArray(exclude) ? exclude : [
        exclude
    ];
    // normalize to posix path
    const normalizedPath = path.replace(/\\/g, '/');
    return excludes.some((reg)=>reg.test(normalizedPath));
}
function displayCodePointer(code, pos) {
    const SUB_LEN = 80;
    const start = Math.max(pos - SUB_LEN / 2, 0);
    const subCode = code.slice(start, start + SUB_LEN);
    const arrowPos = pos - start;
    const arrowLine = external_picocolors_default().yellow('^'.padStart(arrowPos + 11, ' '));
    return `${subCode}\n${arrowLine}`;
}
async function generateError({ err, code, filepath, rootPath, exclude }) {
    let error = await tryGenerateErrorFromSourceMap({
        err,
        filepath,
        rootPath
    });
    if (!error) {
        const path = filepath.replace(rootPath, '');
        error = new ECMASyntaxError(err.message, {
            source: {
                path,
                line: err.loc.line,
                column: err.loc.column,
                code: displayCodePointer(code, err.pos)
            }
        });
    }
    if (checkIsExclude(error.source.path, exclude)) return null;
    return error;
}
function makeCodeFrame(lines, highlightIndex) {
    const startLine = Math.max(highlightIndex - 3, 0);
    const endLine = Math.min(highlightIndex + 4, lines.length - 1);
    const ret = [];
    for(let i = startLine; i < endLine; i++)if (i === highlightIndex) {
        const lineNumber = `> ${i + 1}`.padStart(6, ' ');
        ret.push(external_picocolors_default().yellow(`${lineNumber} | ${lines[i]}`));
    } else {
        const lineNumber = ` ${i + 1}`.padStart(6, ' ');
        ret.push(external_picocolors_default().gray(`${lineNumber} | ${lines[i]}`));
    }
    return `\n${ret.join('\n')}`;
}
async function tryGenerateErrorFromSourceMap({ err, filepath, rootPath }) {
    const sourceMapPath = `${filepath}.map`;
    if (!external_node_fs_default().existsSync(sourceMapPath)) return null;
    try {
        var _JSON_parse_sourcesContent, _JSON_parse;
        const sourcemap = await external_node_fs_default().promises.readFile(sourceMapPath, 'utf-8');
        const consumer = await new external_source_map_namespaceObject.SourceMapConsumer(sourcemap);
        const sm = consumer.originalPositionFor({
            line: err.loc.line,
            column: err.loc.column
        });
        if (!sm.source) return null;
        const { sources } = consumer;
        const smIndex = sources.indexOf(sm.source);
        const smContent = null === (_JSON_parse = JSON.parse(sourcemap)) || void 0 === _JSON_parse ? void 0 : null === (_JSON_parse_sourcesContent = _JSON_parse.sourcesContent) || void 0 === _JSON_parse_sourcesContent ? void 0 : _JSON_parse_sourcesContent[smIndex];
        if (!smContent) return null;
        const path = sm.source.replace(/webpack:\/\/(tmp)?/g, '');
        const relativeFilepath = filepath.replace(rootPath, '');
        const rawLines = smContent.split(/\r?\n/g);
        const highlightLine = (sm.line ?? 1) - 1;
        return new ECMASyntaxError(err.message, {
            source: {
                path,
                line: sm.line ?? 0,
                column: sm.column ?? 0,
                code: makeCodeFrame(rawLines, highlightLine)
            },
            output: {
                path: relativeFilepath,
                line: err.loc.line,
                column: err.loc.column
            }
        });
    } catch (e) {
        return null;
    }
}
const external_htmlparser2_namespaceObject = require("htmlparser2");
async function generateHtmlScripts(filepath) {
    const html = await external_node_fs_default().promises.readFile(filepath, 'utf-8');
    return getHtmlScripts(html);
}
function getHtmlScripts(html) {
    const inlineScripts = [];
    let currentScript = null;
    const parser = new external_htmlparser2_namespaceObject.Parser({
        onopentag (name, attrs) {
            if ('script' === name && !attrs.src && (!attrs.type || 'application/javascript' === attrs.type || 'text/javascript' === attrs.type)) currentScript = '';
        },
        ontext (text) {
            if (null !== currentScript) currentScript += text;
        },
        onclosetag (tagname) {
            if ('script' === tagname && currentScript) inlineScripts.push(currentScript.trim());
            currentScript = null;
        }
    });
    parser.write(html);
    parser.end();
    return inlineScripts;
}
function checkSyntax_define_property(obj, key, value) {
    if (key in obj) Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
    });
    else obj[key] = value;
    return obj;
}
const HTML_REGEX = /\.html$/;
const JS_REGEX = /\.(?:js|mjs|cjs|jsx)$/;
class CheckSyntax {
    async check(filepath, code) {
        // If the code is provided, no need to read file.
        if (code) return await this.tryParse(filepath, code);
        if (HTML_REGEX.test(filepath)) {
            const htmlScripts = await generateHtmlScripts(filepath);
            await Promise.all(htmlScripts.map(async (script)=>{
                if (!checkIsExclude(filepath, this.exclude)) await this.tryParse(filepath, script);
            }));
        }
        if (JS_REGEX.test(filepath)) {
            const jsScript = await external_node_fs_default().promises.readFile(filepath, 'utf-8');
            await this.tryParse(filepath, jsScript);
        }
    }
    async tryParse(filepath, code) {
        try {
            (0, external_acorn_namespaceObject.parse)(code, {
                ecmaVersion: this.ecmaVersion
            });
        } catch (_) {
            const err = _;
            const error = await generateError({
                err,
                code,
                filepath,
                exclude: this.exclude,
                rootPath: this.rootPath
            });
            if (error) this.errors.push(error);
        }
    }
    constructor(options){
        checkSyntax_define_property(this, "errors", []);
        checkSyntax_define_property(this, "ecmaVersion", void 0);
        checkSyntax_define_property(this, "targets", void 0);
        checkSyntax_define_property(this, "rootPath", void 0);
        checkSyntax_define_property(this, "exclude", void 0);
        checkSyntax_define_property(this, "excludeOutput", void 0);
        this.targets = options.targets;
        this.exclude = options.exclude;
        this.excludeOutput = options.excludeOutput;
        this.rootPath = options.rootPath;
        this.ecmaVersion = options.ecmaVersion || (0, external_browserslist_to_es_version_namespaceObject.browserslistToESVersion)(this.targets);
    }
}
const core_namespaceObject = require("@rsbuild/core");
function printErrors(errors, ecmaVersion) {
    if (0 === errors.length) {
        core_namespaceObject.logger.success('[@rsbuild/plugin-check-syntax] Syntax check passed.');
        return;
    }
    const errs = errors.map((error)=>({
            source: `${error.source.path}:${error.source.line}:${error.source.column}`,
            output: error.output ? `${error.output.path}:${error.output.line}:${error.output.column}` : void 0,
            reason: error.message,
            code: error.source.code
        }));
    const longest = Math.max(...Object.keys(errs[0]).map((err)=>err.length));
    const expectedVersion = external_picocolors_default().yellow(`ecmaVersion <= ${ecmaVersion}`);
    core_namespaceObject.logger.error(`[@rsbuild/plugin-check-syntax] Find some syntax that does not match "${expectedVersion}":\n`);
    errs.forEach((err, index)=>{
        console.log(external_picocolors_default().bold(external_picocolors_default().red(`  ERROR ${index + 1}`)));
        printMain(err, longest);
    });
    throw new Error(`[@rsbuild/plugin-check-syntax] The current build fails due to an incompatible syntax, which can be fixed in the following ways:

  - If you want to downgrade the syntax, you can compile the specified module through the \`source.include\` config.
  - If you don't want to downgrade the syntax, you can adjust the project's browserslist to match the syntax, or set the \`ecmaVersion\` option.
  - If you don't want to check the syntax of specified files, you can use the \`exclude\` option to exclude the files to be checked.\n`);
}
function printMain(error, longest) {
    const fillWhiteSpace = (s, longest)=>{
        if (s.length < longest) {
            const rightPadding = ' '.repeat(longest - s.length);
            return s + rightPadding;
        }
        return s;
    };
    for (const [key, content] of Object.entries(error)){
        if (!content) continue;
        const title = external_picocolors_default().magenta(`${fillWhiteSpace(`${key}:`, longest + 1)}`);
        console.info(`  ${title}  ${content}`);
    }
    console.info('');
}
const CheckSyntaxPlugin_HTML_REGEX = /\.html$/;
const CheckSyntaxPlugin_JS_REGEX = /\.(?:js|mjs|cjs|jsx)$/;
class CheckSyntaxRspackPlugin extends CheckSyntax {
    apply(compiler) {
        compiler.hooks.afterEmit.tapPromise(CheckSyntaxRspackPlugin.name, async (compilation)=>{
            const outputPath = compilation.outputOptions.path || 'dist';
            // not support compilation.emittedAssets in Rspack
            const emittedAssets = compilation.getAssets().filter((a)=>a.source).map((a)=>{
                // remove query from name
                const resourcePath = a.name.split('?')[0];
                const file = (0, external_node_path_namespaceObject.resolve)(outputPath, resourcePath);
                if (!checkIsExclude(file, this.excludeOutput)) return file;
                return '';
            });
            const files = emittedAssets.filter((assets)=>CheckSyntaxPlugin_HTML_REGEX.test(assets) || CheckSyntaxPlugin_JS_REGEX.test(assets));
            await Promise.all(files.map(async (file)=>{
                await this.check(file);
            }));
            printErrors(this.errors, this.ecmaVersion);
        });
    }
}
const PLUGIN_CHECK_SYNTAX_NAME = 'rsbuild:check-syntax';
function pluginCheckSyntax(options = {}) {
    return {
        name: PLUGIN_CHECK_SYNTAX_NAME,
        setup (api) {
            api.modifyBundlerChain(async (chain, { isDev, target, environment })=>{
                if (isDev || 'web' !== target) return;
                const { rootPath } = api.context;
                const targets = options.targets ?? environment.browserslist;
                chain.plugin(CheckSyntaxRspackPlugin.name).use(CheckSyntaxRspackPlugin, [
                    {
                        targets,
                        rootPath,
                        ...'object' == typeof options ? options : {}
                    }
                ]);
            });
        }
    };
}
var __webpack_export_target__ = exports;
for(var __webpack_i__ in __webpack_exports__)__webpack_export_target__[__webpack_i__] = __webpack_exports__[__webpack_i__];
if (__webpack_exports__.__esModule) Object.defineProperty(__webpack_export_target__, '__esModule', {
    value: true
});
